//+------------------------------------------------------------------+
//|                                                         CCFp.mq4 |
//|                                              SemSemFX@rambler.ru |
//|              http://onix-trade.net/forum/index.php?showtopic=107 |
//+------------------------------------------------------------------+
#property copyright "SemSemFX@rambler.ru"
#property link      "http://onix-trade.net/forum/index.php?showtopic=107"
//---
#include <stderror.mqh>
#include <stdlib.mqh>
#include <WinUser32.mqh>
//----
string Indicator_Name = "CL8v:";
int Objs = 0;
//----
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Brown     //   
#property indicator_color2 Red
#property indicator_color3 Peru
#property indicator_color4 Tan
#property indicator_color5 Green
#property indicator_color6 Chartreuse
#property indicator_color7 MediumBlue
#property indicator_color8 White
//---
extern int History = 1440; //    
extern int MA_Method = MODE_SMA;
extern int Price = PRICE_WEIGHTED;
extern int Fast = 14;

extern bool EUR = 1;
extern bool GBP = 1;
extern bool AUD = 1;
extern bool NZD = 1;
extern bool CAD = 1;
extern bool CHF = 1;
extern bool JPY = 1;
extern bool USD = 1;

extern color Color_EUR = Brown;
extern color Color_GBP = Red;
extern color Color_AUD = Peru;
extern color Color_NZD = Tan;
extern color Color_CAD = Green;
extern color Color_CHF = Chartreuse;
extern color Color_JPY = MediumBlue;
extern color Color_USD = White;
extern int   Line_Thickness = 2;


//----
double arrEUR_0[];
double arrGBP_1[];
double arrAUD_2[];
double arrNZD_3[];
double arrCAD_4[];
double arrCHF_5[];
double arrJPY_6[];
double arrUSD_7[];

//---
string CV     [8] = {"EUR","GBP","AUD","NZD","CAD","CHF","JPY","USD"};
double CV_move[8];

//---
string S [28]=
{
"EURUSD", // EURUSD        0    0
"GBPUSD", // GBPUSD        1    1
"AUDUSD", // AUDUSD        2    2
"NZDUSD", // NZDUSD        3    3
"USDCAD", // USDCAD        4    4
"USDCHF", // USDCHF        5    5
"USDJPY", // USDJPY        6    6

"EURGBP", // EURUSD/GBPUSD 7    0/1
"EURAUD", // EURUSD/AUDUSD 8    0/2
"EURNZD", // EURUSD/NZDUSD 9    0/3
"EURCAD", // EURUSD*USDCAD 10   0*4
"EURCHF", // EURUSD*USDCHF 11   0*5
"EURJPY", // EURUSD*USDJPY 12   0*6

"GBPAUD", // GBPUSD/AUDUSD 13   1/2
"GBPNZD", // GBPUSD/NZDUSD 14   1/3 
"GBPCAD", // GBPUSD*USDCAD 15   1*4
"GBPCHF", // GBPUSD*USDCHF 16   1*5
"GBPJPY", // GBPUSD*USDJPY 17   1*6

"AUDNZD", // AUDUSD/NZDUSD 18   2/3
"AUDCAD", // AUDUSD*USDCAD 19   2*4
"AUDCHF", // AUDUSD*USDCHF 20   2*5
"AUDJPY", // AUDUSD*USDJPY 21   2*6

"NZDCAD", // NZDUSD*USDCAD 22   3*4
"NZDCHF", // NZDUSD*USDCHF 23   3*5
"NZDJPY", // NZDUSD*USDJPY 24   3*6


"CADCHF", // USDCHF/USDCAD 25   5/4
"CADJPY", // USDJPY/USDCAD 26   6/4

"CHFJPY"  // USDJPY/USDCHF 27   6/5
};
//---
double S_curr_v[28];
double S_prev_v[28];
double S_move;
//---
int    SD[28];
double SP[28];
//---
string SL[28] =
{"EUR","GBP","AUD","NZD","USD","USD","USD","EUR","EUR","EUR","EUR","EUR","EUR","GBP","GBP","GBP","GBP","GBP",
 "AUD","AUD","AUD","AUD","NZD","NZD","NZD","CAD","CAD","CHF"};   

string SR[28] = 
{"USD","USD","USD","USD","CAD","CHF","JPY","GBP","AUD","NZD","CAD","CHF","JPY","AUD","NZD","CAD","CHF","JPY",
 "NZD","CAD","CHF","JPY","CAD","CHF","JPY","CHF","JPY","JPY"};   
int i,j,k,Counted_bars;
double dv;
string sv;
int    last_error;
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
//--------------------------------------------------------------------
int start()                          
  {
//--------------------------------------------------------------------
   Counted_bars = IndicatorCounted(); //    
   i = Bars - Counted_bars - 1;       //   
   if (i > History-1)                 //     ..
      i = History-1;                  // ..  .
//***     Print("Counted_bars1= ",Counted_bars," i=",i);
//-----------------------------------------------------------------------      
   while(i >= 0)                      //    
   {
//---
//***     Print("Counted_bars2= ",Counted_bars," i=",i);
     for (k = 0; k <= 6; k++)
     {
       last_error = 1;
       while (last_error != 0)
       {
         S_curr_v[k] = iMA(S[k],Period(),Fast,0,MA_Method,Price,i+0); last_error = GetLastError();
//***         sv = StringConcatenate("start():",i," iMA(",S[k],"= ",NormalizeDouble(S_curr_v[k],SD[k]),","," TimeFrame =",Period()," Period=",Fast," ma_metod=",MA_Method," applied_price=",Price,
//***                              " shift=",i,")","   :", last_error,"-",ErrorDescription(last_error));
//***         Print(sv);
       } // while (last_error != 0)   
//---       
       last_error = 1;
       while (last_error != 0)
       {
         S_prev_v[k] = iMA(S[k],Period(),Fast,0,MA_Method,Price,i+1); last_error = GetLastError();
//***         sv = StringConcatenate("start():",i," iMA(",S[k],"= ",NormalizeDouble(S_prev_v[k],SD[k]),","," TimeFrame =",Period()," Period=",Fast," ma_metod=",MA_Method," applied_price=",Price,
//***                              " shift=",i+1,")","   :", last_error,"-",ErrorDescription(last_error));
//***         Print(sv);
       } // while (last_error != 0)   
     } // for (k = 0; k <= 6; k++)   
//***     Print("S_cross()");
     S_cross();
//---    
     ArrayInitialize(CV_move, 0);
//---
     for (k = 0; k <= 27; k++)
     {
       S_move   = NormalizeDouble(S_curr_v[k]/S_prev_v[k],SD[k]);
       S_move   = NormalizeDouble(S_move -1,SD[k]);
       S_move   = NormalizeDouble(S_move/SP[k],0);
       for (j = 0; j <= 7; j++)
       {
        if (SL[k] == CV[j]) CV_move[j] += S_move;
        if (SR[k] == CV[j]) CV_move[j] -= S_move;        
       }        
     } //   for (k = 0; k <= 27; k++)
//---     
     arrEUR_0[i] = CV_move[0];
     arrGBP_1[i] = CV_move[1];
     arrAUD_2[i] = CV_move[2];
     arrNZD_3[i] = CV_move[3];
     arrCAD_4[i] = CV_move[4];
     arrCHF_5[i] = CV_move[5];
     arrJPY_6[i] = CV_move[6];
     arrUSD_7[i] = CV_move[7];         
//---           
      i--;                          //    
   }  //   while(i >= 0) 
//--------------------------------------------------------------------
   return;                          //   . - start()
  }
//--------------------------------------------------------------------
void S_cross()
{
 S_curr_v[7]  = S_curr_v[0]/S_curr_v[1];
 S_curr_v[8]  = S_curr_v[0]/S_curr_v[2];
 S_curr_v[9]  = S_curr_v[0]/S_curr_v[3]; 
 S_curr_v[10] = S_curr_v[0]*S_curr_v[4];  
 S_curr_v[11] = S_curr_v[0]*S_curr_v[5];  
 S_curr_v[12] = S_curr_v[0]*S_curr_v[6]; 
 
 S_curr_v[13] = S_curr_v[1]/S_curr_v[2];  
 S_curr_v[14] = S_curr_v[1]/S_curr_v[3];
 S_curr_v[15] = S_curr_v[1]*S_curr_v[4];
 S_curr_v[16] = S_curr_v[1]*S_curr_v[5]; 
 S_curr_v[17] = S_curr_v[1]*S_curr_v[6];  
 
 S_curr_v[18] = S_curr_v[2]/S_curr_v[3];  
 S_curr_v[19] = S_curr_v[2]*S_curr_v[4]; 
 S_curr_v[20] = S_curr_v[2]*S_curr_v[5];  
 S_curr_v[21] = S_curr_v[2]*S_curr_v[6];
 
 S_curr_v[22] = S_curr_v[3]*S_curr_v[4];
 S_curr_v[23] = S_curr_v[3]*S_curr_v[5]; 
 S_curr_v[24] = S_curr_v[3]*S_curr_v[6];  
 
 S_curr_v[25] = S_curr_v[5]/S_curr_v[4];  
 S_curr_v[26] = S_curr_v[6]/S_curr_v[4]; 
 
 S_curr_v[27] = S_curr_v[6]/S_curr_v[5];  
//-------------------------------------
 S_prev_v[7]  = S_prev_v[0]/S_prev_v[1];
 S_prev_v[8]  = S_prev_v[0]/S_prev_v[2];
 S_prev_v[9]  = S_prev_v[0]/S_prev_v[3]; 
 S_prev_v[10] = S_prev_v[0]*S_prev_v[4];  
 S_prev_v[11] = S_prev_v[0]*S_prev_v[5];  
 S_prev_v[12] = S_prev_v[0]*S_prev_v[6]; 
 
 S_prev_v[13] = S_prev_v[1]/S_prev_v[2];  
 S_prev_v[14] = S_prev_v[1]/S_prev_v[3];
 S_prev_v[15] = S_prev_v[1]*S_prev_v[4];
 S_prev_v[16] = S_prev_v[1]*S_prev_v[5]; 
 S_prev_v[17] = S_prev_v[1]*S_prev_v[6];  
 
 S_prev_v[18] = S_prev_v[2]/S_prev_v[3];  
 S_prev_v[19] = S_prev_v[2]*S_prev_v[4]; 
 S_prev_v[20] = S_prev_v[2]*S_prev_v[5];  
 S_prev_v[21] = S_prev_v[2]*S_prev_v[6];
 
 S_prev_v[22] = S_prev_v[3]*S_prev_v[4];
 S_prev_v[23] = S_prev_v[3]*S_prev_v[5]; 
 S_prev_v[24] = S_prev_v[3]*S_prev_v[6];  
 
 S_prev_v[25] = S_prev_v[5]/S_prev_v[4];  
 S_prev_v[26] = S_prev_v[6]/S_prev_v[4]; 
 
 S_prev_v[27] = S_prev_v[6]/S_prev_v[5];  

//---
 return;
}
//----------------------------------------------------------------------------
double MarketInfoF(string Sym,int Mode)
{
 double MarketInfoRes;
//---
 if (Sym != "GBPNZD") {MarketInfoRes = MarketInfo(Sym,Mode);}
 else 
 {
  switch(Mode)
  {
   case MODE_DIGITS  : MarketInfoRes = 5      ; break; 
   case MODE_POINT   : MarketInfoRes = 0.00001; break;
   case MODE_BID     : MarketInfoRes = NormalizeDouble(MarketInfo("GBPUSD",MODE_BID)/MarketInfo("NZDUSD",MODE_BID),5);  break; 
  }     
 }
//--- 
 if (MarketInfoRes <= 0) 
 {
  PlaySound("alert.wav");
  sv = StringConcatenate("MarketInfo(",Sym,",",Mode,")","  ", MarketInfoRes);
  Print(sv);
 }
 return(MarketInfoRes);
}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   if(EUR)
       Indicator_Name = StringConcatenate(Indicator_Name, " EUR");
   if(GBP)
       Indicator_Name = StringConcatenate(Indicator_Name, " GBP");
   if(AUD)
       Indicator_Name = StringConcatenate(Indicator_Name, " AUD");
   if(NZD)
       Indicator_Name = StringConcatenate(Indicator_Name, " NZD");
   if(CAD)
       Indicator_Name = StringConcatenate(Indicator_Name, " CAD");
   if(CHF)
       Indicator_Name = StringConcatenate(Indicator_Name, " CHF");
   if(JPY)
       Indicator_Name = StringConcatenate(Indicator_Name, " JPY");       
   if(USD)
       Indicator_Name = StringConcatenate(Indicator_Name, " USD");
   IndicatorShortName(Indicator_Name);
   int cur = 0; 
   int st = 23; 
//---   
   if(EUR)
     {
       sl("~", cur, Color_EUR);
       cur += st;
     }
//---     
   if(GBP)
     {
       sl("~", cur, Color_GBP);
       cur += st;
     }
//---     
   if(AUD)
     {
       sl("~", cur, Color_AUD);
       cur += st;
     }
//---     
   if(NZD)
     {
       sl("~", cur, Color_NZD);
       cur += st;
     }
//---     
   if(CAD)
     {
       sl("~", cur, Color_CAD);
       cur += st;
     }
//---     
   if(CHF)
     {
       sl("~", cur, Color_CHF);
       cur += st;
     }
//---          
    if(JPY)
     {
       sl("~", cur, Color_JPY);
       cur += st;
     }
//---    
   if(USD)
     {
       sl("~", cur, Color_USD);
       cur += st;
     }     
//---
   int width = 0;
   if(0 > StringFind(Symbol(), "EUR", 0))
       width = 1;
   else 
       width = Line_Thickness;
   SetIndexStyle (0, DRAW_LINE, DRAW_LINE, width, Color_EUR);
   SetIndexBuffer(0, arrEUR_0);
   SetIndexLabel (0, "EUR"); 
//---   
   if(0 > StringFind(Symbol(), "GBP", 0))
       width = 1;
   else 
       width = Line_Thickness;
   SetIndexStyle (1, DRAW_LINE, DRAW_LINE, width, Color_GBP);
   SetIndexBuffer(1, arrGBP_1);
   SetIndexLabel (1, "GBP"); 
//---   
   if(0 > StringFind(Symbol(), "AUD", 0))
       width = 1;
   else 
       width = Line_Thickness;
   SetIndexStyle (2, DRAW_LINE, DRAW_LINE, width, Color_AUD);
   SetIndexBuffer(2, arrAUD_2);
   SetIndexLabel (2, "AUD"); 
//---   
   if(0 > StringFind(Symbol(), "NZD", 0))
       width = 1;
   else 
       width = Line_Thickness;
   SetIndexStyle (3, DRAW_LINE, DRAW_LINE, width, Color_NZD);
   SetIndexBuffer(3, arrNZD_3);
   SetIndexLabel (3, "NZD"); 

//----
   if(0 > StringFind(Symbol(), "CAD", 0))
       width = 1;
   else 
       width = Line_Thickness;
   SetIndexStyle (4, DRAW_LINE, DRAW_LINE, width, Color_CAD);
   SetIndexBuffer(4, arrCAD_4);
   SetIndexLabel (4, "CAD"); 
//--- 
   if(0 > StringFind(Symbol(), "CHF", 0))
       width = 1;
   else 
       width = Line_Thickness;
   SetIndexStyle (5, DRAW_LINE, DRAW_LINE, width, Color_CHF);
   SetIndexBuffer(5, arrCHF_5);
   SetIndexLabel (5, "CHF"); 
//---   
  

   if(0 > StringFind(Symbol(), "JPY", 0))
       width = 1;
   else 
       width = Line_Thickness;
   SetIndexStyle (6, DRAW_LINE, DRAW_LINE, width, Color_JPY);
   SetIndexBuffer(6, arrJPY_6);
   SetIndexLabel (6, "JPY"); 
//---   
   if(0 > StringFind(Symbol(), "USD", 0))
       width = 1;
   else 
       width = Line_Thickness;
   SetIndexStyle (7, DRAW_LINE, DRAW_LINE, width, Color_USD);
   SetIndexBuffer(7, arrUSD_7);
   SetIndexLabel (7, "USD"); 
//---   

   for (i = 0; i <=27; i++)
   {
     SD[i] = MarketInfoF(S[i],MODE_DIGITS);
     SP[i] = MarketInfoF(S[i],MODE_POINT) ;
   } // end for (i = 0; i <=27; i++)
//---   
   Print("Init() ended..............");
//----
   return(0);
  }
//+------------------------------------------------------------------+
void sl(string sym, int y, color col)
  {
   int window = WindowFind(Indicator_Name);
   string ID = Indicator_Name+Objs;
   int tmp = 10 + y;
   Objs++;
   if(ObjectCreate(ID, OBJ_LABEL, window, 0, 0))
     {
       //ObjectSet(ID, OBJPROP_CORNER, 1);
       ObjectSet(ID, OBJPROP_XDISTANCE, y + 35);
       ObjectSet(ID, OBJPROP_YDISTANCE, 0);
       ObjectSetText(ID, sym, 18, "Arial Black", col);
     }
  }   
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(i = 0; i < Objs; i++)
     {
      if(!ObjectDelete(Indicator_Name + i))
          Print("error: code #", GetLastError());
     }
//----
   return(0);
  }
//----------------------------------------------------------------------------

